/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.telenor.rest;

import java.util.List;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.GenericEntity;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import rs.telenor.kolekcija.Kolekcija;
import rs.telenor.model.City;

/**
 *
 * @author Korisnik
 */
@Path("city")
public class CityRest {

    // private Kolekcija k = new Kolekcija();
    @POST
    @Path("save")
    @Consumes(MediaType.APPLICATION_XML)
    @Produces(MediaType.TEXT_PLAIN)
    public Response save(City city) {
        Kolekcija.getInstance().save(city);
        return Response.ok("Saved").build();
    }

    @GET
    @Path("all")
    @Produces(MediaType.APPLICATION_XML)
    public Response findAll(@HeaderParam ("TELENOR_KEY") String key) {
        if (key != null && key.equalsIgnoreCase("abc")) {
            List<City> list = Kolekcija.getInstance().findAll();
            GenericEntity<List<City>> ge = new GenericEntity<List<City>>(list) {};
            return Response.ok(ge).build();
        }
        return Response.status(Response.Status.FORBIDDEN).encoding("Restricted!").build();
    }

    @GET
    @Path("ptt/{ptt}")
    @Produces(MediaType.APPLICATION_XML)
    public Response find(@PathParam("ptt") long ptt) {
        City c = Kolekcija.getInstance().find(ptt);
        if (c != null) {
            return Response.ok(c).build();
        }
        return Response.status(Response.Status.NOT_FOUND).entity("Not Found!!!").build();
    }
    
    @PUT
    @Path("update")
    @Consumes(MediaType.APPLICATION_XML)
    @Produces(MediaType.APPLICATION_XML)
    public Response update(City city) {
        City c = Kolekcija.getInstance().update(city);
        if (c != null) {
            return Response.ok(c).build();
        }
        return Response.status(Response.Status.NOT_FOUND).entity("Not Found!!!").build();
    }

}
